libzypp: zypp::Capabilities Class Reference

libzypp 17.25.10

Classes | Public Types | Public Member Functions | Private Attributes | Related Functions | List of all members
zypp::Capabilities Class Reference

Container of Capability (currently read only). More...

`#include <Capabilities.h>`

## Classes
class | const_iterator
| Capabilities iterator. More...

## Public Types
enum | Mode { SKIP_TO_INTERNAL }
typedef Capability | value_type
typedef unsigned | size_type

## Public Member Functions
| Capabilities ()
| Default ctor. More...
| Capabilities (const sat::detail::IdType *base_r)
| Ctor from Id pointer (friend Solvable). More...
| Capabilities (const sat::detail::IdType *base_r, sat::detail::IdType skip_r)
| Ctor from Id pointer (friend Solvable). More...
bool | empty () const
| Whether the container is empty. More...
size_type | size () const
| Number of capabilities inside. More...
const_iterator | begin () const
| Iterator pointing to the first Capability. More...
const_iterator | end () const
| Iterator pointing behind the last Capability. More...
bool | contains (const Capability &lhs) const
| Return whether the set contains lhs (the Id) More...
bool | matches (const Capability &lhs) const
| Return whether lhs matches at least one capability in set. More...

## Private Attributes
const sat::detail::IdType * | _begin

## Related Functions
(Note that these are not member functions.)
std::ostream & | operator<< (std::ostream &str, const Capabilities &obj)
| Stream output. More...

## Detailed Description

Container of Capability (currently read only).

Note
  libsolv dependency lists may include internal ids which must be skipped on iteration or size calculation (

See also
  detail::isDepMarkerId).

Definition at line 35 of file Capabilities.h.

## Member Typedef Documentation

## ◆ value_type

typedef Capability zypp::Capabilities::value_type

Definition at line 38 of file Capabilities.h.

## ◆ size_type

typedef unsigned zypp::Capabilities::size_type

Definition at line 39 of file Capabilities.h.

## Member Enumeration Documentation

## ◆ Mode

enum zypp::Capabilities::Mode

Enumerator
SKIP_TO_INTERNAL |

Definition at line 41 of file Capabilities.h.

## Constructor & Destructor Documentation

## ◆ Capabilities() [1/3]

zypp::Capabilities::Capabilities | ( |  | ) |
| inline

Default ctor.

Definition at line 45 of file Capabilities.h.

## ◆ Capabilities() [2/3]

zypp::Capabilities::Capabilities | ( | const sat::detail::IdType * | base_r | ) |
| inlineexplicit

Ctor from Id pointer (friend Solvable).

Definition at line 51 of file Capabilities.h.

## ◆ Capabilities() [3/3]

zypp::Capabilities::Capabilities | ( | const sat::detail::IdType * | base_r,
|  | sat::detail::IdType | skip_r
| ) |  |

Ctor from Id pointer (friend Solvable).

Jump behind skip_r (e.g. behind prereqMarker).

Definition at line 23 of file Capabilities.cc.

## Member Function Documentation

## ◆ empty()

bool zypp::Capabilities::empty | ( |  | ) | const
| inline

Whether the container is empty.

Definition at line 62 of file Capabilities.h.

## ◆ size()

Capabilities::size_type zypp::Capabilities::size | ( |  | ) | const

Number of capabilities inside.

Definition at line 45 of file Capabilities.cc.

## ◆ begin()

Capabilities::const_iterator zypp::Capabilities::begin | ( |  | ) | const
| inline

Iterator pointing to the first Capability.

Definition at line 169 of file Capabilities.h.

## ◆ end()

Capabilities::const_iterator zypp::Capabilities::end | ( |  | ) | const
| inline

Iterator pointing behind the last Capability.

Definition at line 172 of file Capabilities.h.

## ◆ contains()

bool zypp::Capabilities::contains | ( | const Capability & | lhs | ) | const
| inline

Return whether the set contains lhs (the Id)

Definition at line 175 of file Capabilities.h.

## ◆ matches()

bool zypp::Capabilities::matches | ( | const Capability & | lhs | ) | const
| inline

Return whether lhs matches at least one capability in set.

Definition at line 183 of file Capabilities.h.

## Friends And Related Function Documentation

## ◆ operator<<()

std::ostream & operator<< | ( | std::ostream & | str,
|  | const Capabilities & | obj
| ) |  |
| related

Stream output.

Definition at line 65 of file Capabilities.cc.

## Member Data Documentation

## ◆ _begin

const sat::detail::IdType* zypp::Capabilities::_begin
| private

Definition at line 85 of file Capabilities.h.

The documentation for this class was generated from the following files:

- zypp/Capabilities.h
- zypp/Capabilities.cc